Update zk version to 3.4.14 in dist and install zk in ubuntu 16/18 di… (#3411)

* Update zk version to 3.4.14 in dist and install zk in ubuntu 16/18 dist docker image

* fix path

* Add back docker ARG
diff --git a/docker/base/Dockerfile.base.debian9 b/docker/base/Dockerfile.base.debian9
index d45d592..ebbccf4 100644
--- a/docker/base/Dockerfile.base.debian9
+++ b/docker/base/Dockerfile.base.debian9
@@ -27,36 +27,10 @@
     rm -rf /var/lib/apt/lists/*
 
 # install zookeeper
-ARG ZK_DIST=zookeeper-3.4.10
+ARG ZK_DIST=zookeeper-3.4.14
+ADD base/scripts /opt/heron-docker/scripts
 
-RUN curl -O "https://archive.apache.org/dist/zookeeper/$ZK_DIST/$ZK_DIST.tar.gz" \
-    && tar -xzf $ZK_DIST.tar.gz -C /opt \
-    && rm -r $ZK_DIST.tar.gz \
-    && mv /opt/$ZK_DIST /opt/zookeeper \
-    && rm -rf /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README.txt \
-    /opt/zookeeper/NOTICE.txt \
-    /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README_packaging.txt \
-    /opt/zookeeper/build.xml \
-    /opt/zookeeper/config \
-    /opt/zookeeper/contrib \
-    /opt/zookeeper/dist-maven \
-    /opt/zookeeper/docs \
-    /opt/zookeeper/ivy.xml \
-    /opt/zookeeper/ivysettings.xml \
-    /opt/zookeeper/recipes \
-    /opt/zookeeper/src \
-    /opt/zookeeper/$ZK_DIST.jar.asc \
-    /opt/zookeeper/$ZK_DIST.jar.md5 \
-    /opt/zookeeper/$ZK_DIST.jar.sha1
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
 
 ADD base/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
 ADD base/conf/sandbox.conf /etc/supervisor/conf.d/
-
-RUN mkdir -p /opt/zookeeper/scripts
-ADD base/scripts /opt/zookeeper/scripts
-RUN chmod +x /opt/zookeeper/scripts/generate-zookeeper-config.sh && \
-    chmod +x /opt/zookeeper/scripts/zookeeper-ruok.sh && \
-    chmod +x /opt/zookeeper/scripts/start-zookeeper.sh && \
-    chmod +x /opt/zookeeper/scripts/wait-for-zookeeper.sh
diff --git a/docker/base/scripts/install-zookeeper.sh b/docker/base/scripts/install-zookeeper.sh
new file mode 100644
index 0000000..8c7be96
--- /dev/null
+++ b/docker/base/scripts/install-zookeeper.sh
@@ -0,0 +1,60 @@
+#!/usr/bin/env bash
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+# 
+#   http://www.apache.org/licenses/LICENSE-2.0
+# 
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+if [ "$#" -ne 1 ]; then
+  echo "Usage: $0 zookeeper-<version-number>"
+  echo "Example:"
+  echo "$ $0 zookeeper-3.4.14"
+  exit 1
+fi
+
+ZK_DIST=$1
+
+curl -O "https://archive.apache.org/dist/zookeeper/$ZK_DIST/$ZK_DIST.tar.gz"
+tar -xzf ./$ZK_DIST.tar.gz -C /opt
+rm ./$ZK_DIST.tar.gz
+
+mv /opt/$ZK_DIST /opt/zookeeper
+rm -rf /opt/zookeeper/CHANGES.txt \
+    /opt/zookeeper/README.txt \
+    /opt/zookeeper/NOTICE.txt \
+    /opt/zookeeper/CHANGES.txt \
+    /opt/zookeeper/README_packaging.txt \
+    /opt/zookeeper/build.xml \
+    /opt/zookeeper/config \
+    /opt/zookeeper/contrib \
+    /opt/zookeeper/dist-maven \
+    /opt/zookeeper/docs \
+    /opt/zookeeper/ivy.xml \
+    /opt/zookeeper/ivysettings.xml \
+    /opt/zookeeper/recipes \
+    /opt/zookeeper/src \
+    /opt/zookeeper/$ZK_DIST.jar.asc \
+    /opt/zookeeper/$ZK_DIST.jar.md5 \
+    /opt/zookeeper/$ZK_DIST.jar.sha1
+
+# copy zk scripts
+mkdir -p /opt/zookeeper/scripts
+cp /opt/heron-docker/scripts/generate-zookeeper-config.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/generate-zookeeper-config.sh
+cp /opt/heron-docker/scripts/zookeeper-ruok.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/zookeeper-ruok.sh
+cp /opt/heron-docker/scripts/start-zookeeper.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/
+cp /opt/heron-docker/scripts/wait-for-zookeeper.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/wait-for-zookeeper.sh
diff --git a/docker/dist/Dockerfile.dist.centos7 b/docker/dist/Dockerfile.dist.centos7
index 950c40a..88b856c 100644
--- a/docker/dist/Dockerfile.dist.centos7
+++ b/docker/dist/Dockerfile.dist.centos7
@@ -50,3 +50,12 @@
 
 ENV HERON_HOME /heron/heron-core/
 RUN export HERON_HOME
+
+# install zookeeper
+ARG ZK_DIST=zookeeper-3.4.14
+ADD dist/scripts /opt/heron-docker/scripts
+
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
+
+ADD dist/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
+ADD dist/conf/sandbox.conf /etc/supervisor/conf.d/
diff --git a/docker/dist/Dockerfile.dist.debian9 b/docker/dist/Dockerfile.dist.debian9
index 94fdaa2..27fba8a 100644
--- a/docker/dist/Dockerfile.dist.debian9
+++ b/docker/dist/Dockerfile.dist.debian9
@@ -49,38 +49,13 @@
     && ln -s /usr/local/heron/release.yaml /heron
 
 ENV HERON_HOME /heron/heron-core/
+RUN export HERON_HOME
 
 # install zookeeper
-ARG ZK_DIST=zookeeper-3.4.10
+ARG ZK_DIST=zookeeper-3.4.14
+ADD dist/scripts /opt/heron-docker/scripts
 
-RUN curl -O "https://archive.apache.org/dist/zookeeper/$ZK_DIST/$ZK_DIST.tar.gz" \
-    && tar -xzf /heron/$ZK_DIST.tar.gz -C /opt \
-    && rm -r /heron/$ZK_DIST.tar.gz \
-    && mv /opt/$ZK_DIST /opt/zookeeper \
-    && rm -rf /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README.txt \
-    /opt/zookeeper/NOTICE.txt \
-    /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README_packaging.txt \
-    /opt/zookeeper/build.xml \
-    /opt/zookeeper/config \
-    /opt/zookeeper/contrib \
-    /opt/zookeeper/dist-maven \
-    /opt/zookeeper/docs \
-    /opt/zookeeper/ivy.xml \
-    /opt/zookeeper/ivysettings.xml \
-    /opt/zookeeper/recipes \
-    /opt/zookeeper/src \
-    /opt/zookeeper/$ZK_DIST.jar.asc \
-    /opt/zookeeper/$ZK_DIST.jar.md5 \
-    /opt/zookeeper/$ZK_DIST.jar.sha1
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
 
 ADD dist/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
 ADD dist/conf/sandbox.conf /etc/supervisor/conf.d/
-
-RUN mkdir -p /opt/zookeeper/scripts
-ADD dist/scripts /opt/zookeeper/scripts
-RUN chmod +x /opt/zookeeper/scripts/generate-zookeeper-config.sh \
-    && chmod +x /opt/zookeeper/scripts/zookeeper-ruok.sh \
-    && chmod +x /opt/zookeeper/scripts/start-zookeeper.sh \
-    && chmod +x /opt/zookeeper/scripts/wait-for-zookeeper.sh
diff --git a/docker/dist/Dockerfile.dist.ubuntu14.04 b/docker/dist/Dockerfile.dist.ubuntu14.04
index 17930e0..a62b9d5 100644
--- a/docker/dist/Dockerfile.dist.ubuntu14.04
+++ b/docker/dist/Dockerfile.dist.ubuntu14.04
@@ -48,41 +48,13 @@
     && ln -s /usr/local/heron/release.yaml /heron
 
 ENV HERON_HOME /heron/heron-core/
+RUN export HERON_HOME
 
 # install zookeeper
-ARG ZK_DIST=zookeeper-3.4.10
+ARG ZK_DIST=zookeeper-3.4.14
+ADD dist/scripts /opt/heron-docker/scripts
 
-RUN curl -O "https://archive.apache.org/dist/zookeeper/$ZK_DIST/$ZK_DIST.tar.gz" \
-    && tar -xzf /heron/$ZK_DIST.tar.gz -C /opt \
-    && rm -r /heron/$ZK_DIST.tar.gz \
-    && mv /opt/$ZK_DIST /opt/zookeeper \
-    && rm -rf /heron/heron-install.sh \
-    && rm -rf /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README.txt \
-    /opt/zookeeper/NOTICE.txt \
-    /opt/zookeeper/CHANGES.txt \
-    /opt/zookeeper/README_packaging.txt \
-    /opt/zookeeper/build.xml \
-    /opt/zookeeper/config \
-    /opt/zookeeper/contrib \
-    /opt/zookeeper/dist-maven \
-    /opt/zookeeper/docs \
-    /opt/zookeeper/ivy.xml \
-    /opt/zookeeper/ivysettings.xml \
-    /opt/zookeeper/recipes \
-    /opt/zookeeper/src \
-    /opt/zookeeper/$ZK_DIST.jar.asc \
-    /opt/zookeeper/$ZK_DIST.jar.md5 \
-    /opt/zookeeper/$ZK_DIST.jar.sha1
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
 
 ADD dist/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
 ADD dist/conf/sandbox.conf /etc/supervisor/conf.d/
-
-RUN mkdir -p /opt/zookeeper/scripts
-ADD dist/scripts /opt/zookeeper/scripts
-RUN chmod +x /opt/zookeeper/scripts/generate-zookeeper-config.sh \
-    && chmod +x /opt/zookeeper/scripts/zookeeper-ruok.sh \
-    && chmod +x /opt/zookeeper/scripts/start-zookeeper.sh \
-    && chmod +x /opt/zookeeper/scripts/wait-for-zookeeper.sh
-
-CMD ["supervisord", "-n"]
diff --git a/docker/dist/Dockerfile.dist.ubuntu16.04 b/docker/dist/Dockerfile.dist.ubuntu16.04
index cf4be9c..3a63c18 100644
--- a/docker/dist/Dockerfile.dist.ubuntu16.04
+++ b/docker/dist/Dockerfile.dist.ubuntu16.04
@@ -46,7 +46,16 @@
     && ln -s /usr/local/heron/lib /heron/heron-tools \
     && ln -s /usr/local/heron/release.yaml /heron/heron-tools \
     && ln -s /usr/local/heron/examples /heron \
-    && ln -s /usr/local/heron/release.yaml /heron \
+    && ln -s /usr/local/heron/release.yaml /heron
 
 ENV HERON_HOME /heron/heron-core/
 RUN export HERON_HOME
+
+# install zookeeper
+ARG ZK_DIST=zookeeper-3.4.14
+ADD dist/scripts /opt/heron-docker/scripts
+
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
+
+ADD dist/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
+ADD dist/conf/sandbox.conf /etc/supervisor/conf.d/
diff --git a/docker/dist/Dockerfile.dist.ubuntu18.04 b/docker/dist/Dockerfile.dist.ubuntu18.04
index 5913990..5a21d30 100644
--- a/docker/dist/Dockerfile.dist.ubuntu18.04
+++ b/docker/dist/Dockerfile.dist.ubuntu18.04
@@ -44,3 +44,12 @@
 
 ENV HERON_HOME /heron/heron-core/
 RUN export HERON_HOME
+
+# install zookeeper
+ARG ZK_DIST=zookeeper-3.4.14
+ADD dist/scripts /opt/heron-docker/scripts
+
+RUN sh /opt/heron-docker/scripts/install-zookeeper.sh $ZK_DIST
+
+ADD dist/conf/zookeeper.conf /opt/zookeeper/conf/zookeeper.conf
+ADD dist/conf/sandbox.conf /etc/supervisor/conf.d/
diff --git a/docker/dist/scripts/install-zookeeper.sh b/docker/dist/scripts/install-zookeeper.sh
new file mode 100644
index 0000000..8c7be96
--- /dev/null
+++ b/docker/dist/scripts/install-zookeeper.sh
@@ -0,0 +1,60 @@
+#!/usr/bin/env bash
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+# 
+#   http://www.apache.org/licenses/LICENSE-2.0
+# 
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+if [ "$#" -ne 1 ]; then
+  echo "Usage: $0 zookeeper-<version-number>"
+  echo "Example:"
+  echo "$ $0 zookeeper-3.4.14"
+  exit 1
+fi
+
+ZK_DIST=$1
+
+curl -O "https://archive.apache.org/dist/zookeeper/$ZK_DIST/$ZK_DIST.tar.gz"
+tar -xzf ./$ZK_DIST.tar.gz -C /opt
+rm ./$ZK_DIST.tar.gz
+
+mv /opt/$ZK_DIST /opt/zookeeper
+rm -rf /opt/zookeeper/CHANGES.txt \
+    /opt/zookeeper/README.txt \
+    /opt/zookeeper/NOTICE.txt \
+    /opt/zookeeper/CHANGES.txt \
+    /opt/zookeeper/README_packaging.txt \
+    /opt/zookeeper/build.xml \
+    /opt/zookeeper/config \
+    /opt/zookeeper/contrib \
+    /opt/zookeeper/dist-maven \
+    /opt/zookeeper/docs \
+    /opt/zookeeper/ivy.xml \
+    /opt/zookeeper/ivysettings.xml \
+    /opt/zookeeper/recipes \
+    /opt/zookeeper/src \
+    /opt/zookeeper/$ZK_DIST.jar.asc \
+    /opt/zookeeper/$ZK_DIST.jar.md5 \
+    /opt/zookeeper/$ZK_DIST.jar.sha1
+
+# copy zk scripts
+mkdir -p /opt/zookeeper/scripts
+cp /opt/heron-docker/scripts/generate-zookeeper-config.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/generate-zookeeper-config.sh
+cp /opt/heron-docker/scripts/zookeeper-ruok.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/zookeeper-ruok.sh
+cp /opt/heron-docker/scripts/start-zookeeper.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/
+cp /opt/heron-docker/scripts/wait-for-zookeeper.sh /opt/zookeeper/scripts/
+chmod +x /opt/heron-docker/scripts/wait-for-zookeeper.sh